PF-build.sh 32 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_7
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. #### Start check if OSTYPE is supported
  112. # Windows
  113. if [ $OSTYPE == "msys" ]; then
  114. if [ $(uname -m) == "x86_64" ]; then
  115. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  116. Processor="64"
  117. elif [ $(uname -m) == "i386" ]; then
  118. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  119. Processor="32"
  120. fi
  121. # Linux 64-bit
  122. elif [ $OSTYPE == "linux-gnu" ]; then
  123. if [ $(uname -m) == "x86_64" ]; then
  124. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  125. Processor="64"
  126. fi
  127. # Linux 32-bit
  128. elif [ $OSTYPE == "linux-gnu" ]; then
  129. if [ $(uname -m) == "i386" ]; then
  130. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  131. Processor="32"
  132. fi
  133. else
  134. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  135. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  136. echo "Read the notes of build.sh$(tput sgr0)"
  137. exit 1
  138. fi
  139. sleep 2
  140. #### End check if OSTYPE is supported
  141. #### Prepare bash environment and check if wget, zip and other needed things are available
  142. # Check wget
  143. if ! type wget > /dev/null; then
  144. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  145. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  146. exit 2
  147. fi
  148. # Check for zip
  149. if ! type zip > /dev/null; then
  150. if [ $OSTYPE == "msys" ]; then
  151. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  152. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  153. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  154. echo "Run git Bash under Administrator privilege and"
  155. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  156. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  157. exit 3
  158. elif [ $OSTYPE == "linux-gnu" ]; then
  159. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  160. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  161. exit 3
  162. fi
  163. fi
  164. # Check python ... needed during language build
  165. if ! type python > /dev/null; then
  166. if [ $OSTYPE == "msys" ]; then
  167. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  168. exit 4
  169. elif [ $OSTYPE == "linux-gnu" ]; then
  170. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  171. echo "As Python 2.x will not be maintained from 2020 please,"
  172. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  173. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  174. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  175. exit 4
  176. fi
  177. fi
  178. #### End prepare bash environment
  179. #### Set build environment
  180. ARDUINO_ENV="1.8.5"
  181. BUILD_ENV="1.0.6"
  182. BOARD="PrusaResearchRambo"
  183. BOARD_VERSION="1.0.1"
  184. BOARD_URL="https://raw.githubusercontent.com/DRracer/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  185. BOARD_FILENAME="prusa3drambo"
  186. BOARD_FILE_URL="https://raw.githubusercontent.com/DRracer/Arduino_Boards/master/IDE_Board_Manager/prusa3drambo-1.0.1.tar.bz2"
  187. PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env/releases/download/$BUILD_ENV/PF-build-env-$BUILD_ENV.zip"
  188. LIB="PrusaLibrary"
  189. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  190. # List few useful data
  191. echo
  192. echo "Script path :" $SCRIPT_PATH
  193. echo "OS :" $OS
  194. echo "OS type :" $OSTYPE
  195. echo ""
  196. echo "Ardunio IDE :" $ARDUINO_ENV
  197. echo "Build env :" $BUILD_ENV
  198. echo "Board :" $BOARD
  199. echo "Specific Lib:" $LIB
  200. echo ""
  201. #### Start prepare building environment
  202. #Check if build exists and creates it if not
  203. if [ ! -d "../build-env" ]; then
  204. mkdir ../build-env || exit 5
  205. fi
  206. cd ../build-env || exit 6
  207. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  208. # Check if PF-build-env-<version> exists and downloads + creates it if not
  209. # The build environment is based on the supported Arduino IDE portable version with some changes
  210. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  211. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  212. mkdir ../PF-build-env-$BUILD_ENV
  213. sleep 5
  214. fi
  215. # Download and extract supported Arduino IDE depending on OS
  216. # Windows
  217. if [ $OSTYPE == "msys" ]; then
  218. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  219. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  220. sleep 2
  221. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  222. echo "$(tput sgr 0)"
  223. echo "$(tput sgr 0)"
  224. fi
  225. if [ ! -d "../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor" ]; then
  226. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  227. sleep 2
  228. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  229. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor
  230. echo "# arduino-$ARDUINO_ENV-$OSTYPE-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$OSTYPE-$Processor
  231. echo "$(tput sgr0)"
  232. fi
  233. fi
  234. # Linux
  235. if [ $OSTYPE == "linux-gnu" ]; then
  236. # 32 or 64 bit version
  237. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  238. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  239. sleep 2
  240. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  241. echo "$(tput sgr 0)"
  242. echo "$(tput sgr 0)"
  243. fi
  244. if [[ ! -d "../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$OSTYPE-$Processor.txt" ]]; then
  245. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  246. sleep 2
  247. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  248. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor
  249. echo "# arduino-$ARDUINO_ENV-$OSTYPE-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$OSTYPE-$Processor.txt
  250. echo "$(tput sgr0)"
  251. fi
  252. fi
  253. # Make Arduino IDE portable
  254. if [ ! -d ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/ ]; then
  255. mkdir ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable
  256. fi
  257. if [ ! -d ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/output/ ]; then
  258. mkdir ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/output
  259. fi
  260. if [ ! -d ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/ ]; then
  261. mkdir ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages
  262. fi
  263. if [ ! -d ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/sketchbook/ ]; then
  264. mkdir ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/sketchbook
  265. fi
  266. if [ ! -d ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/sketchbook/libraries/ ]; then
  267. mkdir ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/sketchbook/libraries
  268. fi
  269. if [ ! -d ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/staging/ ]; then
  270. mkdir ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/staging
  271. fi
  272. # Change Arduino IDE preferences
  273. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$OSTYPE-$Processor.txt ]; then
  274. echo "$(tput setaf 6)Setting $OSTYPE-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  275. sleep 2
  276. echo "update.check"
  277. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/lib/preferences.txt
  278. echo "board"
  279. sed -i 's/board = uno/board = rambo/g' ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/lib/preferences.txt
  280. echo "editor.linenumbers"
  281. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/lib/preferences.txt
  282. echo "boardsmanager.additional.urls"
  283. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/lib/preferences.txt
  284. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/lib/preferences.txt
  285. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/lib/preferences.txt
  286. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/lib/preferences.txt
  287. echo "# Preferences-$OSTYPE-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$OSTYPE-$Processor.txt
  288. echo "$(tput sgr0)"
  289. fi
  290. # Download and extract Prusa Firmware related parts
  291. # Download and extract PrusaResearchRambo board
  292. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  293. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  294. sleep 2
  295. wget $BOARD_FILE_URL || exit 9
  296. fi
  297. if [[ ! -d "../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/$BOARD/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION-$OSTYPE-$Processor.txt" ]]; then
  298. echo "$(tput setaf 6)Unzipping $BOARD Arduino IDE portable...$(tput setaf 2)"
  299. sleep 2
  300. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  301. if [ ! -d ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/$BOARD ]; then
  302. mkdir ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/$BOARD
  303. fi
  304. if [ ! -d ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/$BOARD ]; then
  305. mkdir ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/$BOARD
  306. fi
  307. if [ ! -d ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/$BOARD/hardware ]; then
  308. mkdir ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/$BOARD/hardware
  309. fi
  310. if [ ! -d ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/$BOARD/hardware/avr ]; then
  311. mkdir ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/$BOARD/hardware/avr
  312. fi
  313. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/$BOARD/hardware/avr/$BOARD_VERSION
  314. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION-$OSTYPE-$Processor.txt
  315. echo "$(tput sgr 0)"
  316. fi
  317. # Download and extract Prusa Firmware specific library files
  318. if [ ! -f "PF-build-env-$BUILD_ENV.zip" ]; then
  319. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  320. sleep 2
  321. wget $PF_BUILD_FILE_URL || exit 11
  322. echo "$(tput sgr 0)"
  323. fi
  324. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$OSTYPE-$Processor.txt" ]; then
  325. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  326. sleep 2
  327. unzip -o PF-build-env-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor || exit 12
  328. echo "# PF-build-env-$OSTYPE-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$OSTYPE-$Processor.txt
  329. echo "$(tput sgr0)"
  330. fi
  331. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  332. if [ -d "../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/arduino/tools" ]; then
  333. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  334. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  335. sleep 2
  336. fi
  337. if [ -d "../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  338. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  339. sleep 2
  340. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  341. sleep 2
  342. cp -f ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  343. echo "# PF-build-env-portable-$OSTYPE-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$OSTYPE-$Processor.txt
  344. echo "$(tput sgr0)"
  345. fi
  346. if [ -d "../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  347. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  348. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  349. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  350. sleep 2
  351. echo "$(tput sgr0)"
  352. exit 13
  353. fi
  354. #### End prepare building
  355. #### Start
  356. cd $SCRIPT_PATH
  357. # First argument defines which variant of the Prusa Firmware will be compiled
  358. if [ -z "$1" ] ; then
  359. # Select which variant of the Prusa Firmware will be compiled, like
  360. PS3="Select a variant: "
  361. while IFS= read -r -d $'\0' f; do
  362. options[i++]="$f"
  363. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  364. select opt in "${options[@]}" "All" "Quit"; do
  365. case $opt in
  366. *.h)
  367. VARIANT=$(basename "$opt" ".h")
  368. VARIANTS[i++]="$opt"
  369. break
  370. ;;
  371. "All")
  372. VARIANT="All"
  373. VARIANTS=${options[*]}
  374. break
  375. ;;
  376. "Quit")
  377. echo "You chose to stop"
  378. exit
  379. ;;
  380. *)
  381. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  382. ;;
  383. esac
  384. done
  385. else
  386. if [ -f "$SCRIPT_PATH/Firmware/variants/$1" ] ; then
  387. VARIANTS=$1
  388. else
  389. echo "$(tput setaf 1)$1 could not be found in Firmware/variants please choose a valid one$(tput setaf 2)"
  390. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  391. echo "$(tput sgr0)"
  392. exit 21
  393. fi
  394. fi
  395. #Second argument defines if it is an english only version. Known values EN_ONLY / ALL
  396. #Check default language mode
  397. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  398. if [ -z "$2" ] ; then
  399. PS3="Select a language: "
  400. echo
  401. echo "Which lang-build do you want?"
  402. select yn in "Multi languages" "English only"; do
  403. case $yn in
  404. "Multi languages")
  405. LANGUAGES="ALL"
  406. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  407. break
  408. ;;
  409. "English only")
  410. LANGUAGES="EN_ONLY"
  411. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  412. break
  413. ;;
  414. *)
  415. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  416. ;;
  417. esac
  418. done
  419. else
  420. if [[ "$2" == "ALL" || "$2" == "EN_ONLY" ]] ; then
  421. LANGUAGES=$2
  422. else
  423. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  424. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as 2nd argument!"
  425. exit 22
  426. fi
  427. fi
  428. #Check if DEV_STATUS is selected via argument 3
  429. if [ ! -z "$3" ] ; then
  430. if [[ "$3" == "GOLD" || "$3" == "RC" || "$3" == "BETA" || "$3" == "ALPHA" || "$3" == "DEVEL" || "$3" == "DEBUG" ]] ; then
  431. DEV_STATUS_SELECTED=$3
  432. else
  433. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  434. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL' or 'DEBUG'$(tput sgr0) are allowed as 3rd argument!$(tput sgr0)"
  435. exit 23
  436. fi
  437. fi
  438. #Set BUILD_ENV_PATH
  439. cd ../PF-build-env-$BUILD_ENV/$OSTYPE-$Processor || exit 24
  440. BUILD_ENV_PATH="$( pwd -P )"
  441. cd ../..
  442. #Checkif BUILD_PATH exists and if not creates it
  443. if [ ! -d "Prusa-Firmware-build" ]; then
  444. mkdir Prusa-Firmware-build || exit 25
  445. fi
  446. #Set the BUILD_PATH for Arduino IDE
  447. cd Prusa-Firmware-build || exit 26
  448. BUILD_PATH="$( pwd -P )"
  449. for v in ${VARIANTS[*]}
  450. do
  451. VARIANT=$(basename "$v" ".h")
  452. # Find firmware version in Configuration.h file and use it to generate the hex filename
  453. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  454. # Find build version in Configuration.h file and use it to generate the hex filename
  455. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  456. # Check if the motherboard is an EINSY and if so only one hex file will generated
  457. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  458. # Check development status
  459. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  460. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  461. if [[ "$DEV_CHECK" == "RC1" || "$DEV_CHECK" == "RC2" ]] ; then
  462. DEV_STATUS="RC"
  463. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  464. DEV_STATUS="ALPHA"
  465. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  466. DEV_STATUS="BETA"
  467. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  468. DEV_STATUS="DEVEL"
  469. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  470. DEV_STATUS="DEBUG"
  471. else
  472. DEV_STATUS="UNKNOWN"
  473. echo
  474. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  475. PS3="Select YES only if source code is tested and trusted: "
  476. select yn in "Yes" "No"; do
  477. case $yn in
  478. Yes)
  479. DEV_STATUS="GOLD"
  480. DEV_STATUS_SELECTED="GOLD"
  481. break
  482. ;;
  483. No)
  484. DEV_STATUS="UNKNOWN"
  485. DEV_STATUS_SELECTED="UNKNOWN"
  486. break
  487. ;;
  488. *)
  489. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  490. ;;
  491. esac
  492. done
  493. fi
  494. else
  495. DEV_STATUS=$DEV_STATUS_SELECTED
  496. fi
  497. #Prepare hex files folders
  498. if [ ! -d "$SCRIPT_PATH/../Hex-files/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  499. mkdir -p $SCRIPT_PATH/../Hex-files/FW$FW-Build$BUILD/$MOTHERBOARD || exit 27
  500. fi
  501. OUTPUT_FOLDER="Hex-files/FW$FW-Build$BUILD/$MOTHERBOARD"
  502. #Check if exactly the same hexfile already exists
  503. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  504. echo ""
  505. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  506. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  507. read -t 10 -p "Press Enter to continue..."
  508. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  509. echo ""
  510. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  511. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  512. read -t 10 -p "Press Enter to continue..."
  513. fi
  514. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  515. echo ""
  516. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  517. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  518. read -t 10 -p "Press Enter to continue..."
  519. fi
  520. #List some useful data
  521. echo "$(tput setaf 2)$(tput setab 7) "
  522. echo "Variant :" $VARIANT
  523. echo "Firmware :" $FW
  524. echo "Build # :" $BUILD
  525. echo "Dev Check :" $DEV_CHECK
  526. echo "DEV Status :" $DEV_STATUS
  527. echo "Motherboard:" $MOTHERBOARD
  528. echo "Languages :" $LANGUAGES
  529. echo "Hex-file Folder:" $OUTPUT_FOLDER
  530. echo "$(tput sgr0)"
  531. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  532. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  533. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  534. else
  535. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  536. read -t 10 -p "Press Enter to continue..."
  537. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  538. fi
  539. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  540. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  541. # set FW_REPOSITORY
  542. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  543. #Prepare english only or multilanguage version to be build
  544. if [ $LANGUAGES == "ALL" ]; then
  545. echo " "
  546. echo "Multi-language firmware will be built"
  547. echo " "
  548. else
  549. echo " "
  550. echo "English only language firmware will be built"
  551. echo " "
  552. fi
  553. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  554. # if [ $OSTYPE == "msys" ]; then
  555. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  556. # fi
  557. #### End of Prepare building
  558. #### Start building
  559. export ARDUINO=$BUILD_ENV_PATH
  560. #echo $BUILD_ENV_PATH
  561. #export BUILDER=$ARDUINO/arduino-builder
  562. echo
  563. #read -t 5 -p "Press Enter..."
  564. echo
  565. echo "Start to build Prusa Firmware ..."
  566. echo "Using variant $VARIANT$(tput setaf 3)"
  567. sleep 2
  568. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD:avr:rambo -ide-version=10805 -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  569. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD:avr:rambo -ide-version=10805 -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  570. echo "$(tput sgr 0)"
  571. if [ $LANGUAGES == "ALL" ]; then
  572. echo "$(tput setaf 2)"
  573. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  574. echo "$(tput sgr 0)"
  575. sleep 2
  576. cd $SCRIPT_PATH/lang
  577. echo "$(tput setaf 3)"
  578. ./config.sh || exit 31
  579. echo "$(tput sgr 0)"
  580. # Check if previous languages and firmware build exist and if so clean them up
  581. if [ -f "lang_en.tmp" ]; then
  582. echo ""
  583. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  584. read -t 10 -p "Press Enter to continue..."
  585. echo "$(tput setaf 3)"
  586. ./lang-clean.sh
  587. echo "$(tput sgr 0)"
  588. fi
  589. if [ -f "progmem.out" ]; then
  590. echo ""
  591. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  592. read -t 10 -p "Press Enter to continue..."
  593. echo "$(tput setaf 3)"
  594. ./fw-clean.sh
  595. echo "$(tput sgr 0)"
  596. fi
  597. # build languages
  598. echo "$(tput setaf 3)"
  599. ./lang-build.sh || exit 32
  600. # Combine compiled firmware with languages
  601. ./fw-build.sh || exit 33
  602. echo "$(tput sgr 0)"
  603. # Check if the motherboard is an EINSY and if so only one hex file will generated
  604. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  605. # If the motherboard is an EINSY just copy one hexfile
  606. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  607. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to Hex-files folder$(tput sgr 0)"
  608. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  609. else
  610. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to Hex-files folder$(tput sgr 0)"
  611. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  612. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  613. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  614. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  615. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  616. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  617. if [ $OSTYPE == "msys" ]; then
  618. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  619. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  620. elif [ $OSTYPE == "linux-gnu" ]; then
  621. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  622. fi
  623. fi
  624. # Cleanup after build
  625. echo "$(tput setaf 3)"
  626. ./fw-clean.sh || exit 34
  627. ./lang-clean.sh || exit 35
  628. echo "$(tput sgr 0)"
  629. else
  630. echo "$(tput setaf 2)Copying English only firmware to Hex-files folder$(tput sgr 0)"
  631. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  632. fi
  633. # Cleanup Firmware
  634. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  635. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  636. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  637. echo $MULTI_LANGUAGE_CHECK
  638. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  639. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  640. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  641. sleep 5
  642. done
  643. # Switch to hex path and list build files
  644. cd $SCRIPT_PATH
  645. cd ..
  646. echo "$(tput setaf 2) "
  647. echo " "
  648. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  649. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  650. #### End building